;---------------------------------------------------------------;
;num_let.asm  a program to show letters that match phone numbers;
; test version 1.0                                              ;
;---------------------------------------------------------------;


print macro                       ;macro to print
   mov   ah,9                     ;to screen
   mov   dx,offset(%1)
   int   21h
   endm

cursor macro                      ;macro to place cursor
   push  bx
   mov   bh,0
   mov   ah,2
   int   10h
   pop   bx
   endm

clrscrn macro                     ;macro to clear screen
   push  ax
   push  bx
   mov   ah,0fh
   int   10h
   mov   ah,0
   int   10h
   pop   bx
   pop   ax
   endm

getn macro                        ;macro to get characters
     mov      ah,1
     int      21h
     endm

lf   equ      0ah                 ;line feed
cr   equ      0dh                 ;carriage return

num_let proc near

start         clrscrn             ;clear screen

     print    opening             ;print opening message

program call    get_num           ;program call routines get 
     call  prn_let                ; number, print letters,
     call  another                ; check if another wanted
     jz    program                ; if yes, jump to start
     mov   ax,4c00h               ; if no, exit
     int   21h

get_num                           ;get number routine
     mov      dx,0903h            ;location for number
     cursor                       ;place cursor
     print    expl_num            ;print message
     mov      cx,7                ;set counter
     mov      ax,offset(sto_num)  ;put address for storing number
     mov      di,ax               ; into di
gn1  getn                         ;get the number
     and      al,0fh              ;strip ascii 3 off
     stosb                        ;store the number
     loop     gn1                 ;loop for all 7 numbers
     ret                          ;return

prn_let                           ;print letters routine
     clrscrn                      ;clear screen
     mov      dx,0105h            ;set cursor postion
     mov      curpos,dx           ;store marker
     cursor                       ;place cursor there
prs  call     sort                ;print a string
     call     curinc              ;move the cursor
     mov      ax,6                ;initialize counter to last one
     mov      count,ax
prt  mov      bx,offset(table1)   ;get address of table
     xlat                         ;put number in al
     inc      al
     cmp      al,2                ;has routine done 0,1,2
     jg       prz                 ;yes, bump up to next
     push     si
     mov      si,count
     mov      [bx+si],al          ;no, store new number
     pop      si
     jmps     prs                 ;go to next string
prz  mov      al,count            ;which count
     cmp      al,0                ;number 1
     jz       prq                 ;if yes, finished
     xor      ax,ax               ;no, then zero
     push     si
     mov      si,count
     mov      [bx+si],al          ;store it
     pop      si
     mov      al,count            ;get count
     dec      al                  ;back up one
     mov      count,al            ;store it
     jmps     prt                 ;jump to test
prq  ret                          ;outta here

curinc mov    ax,curpos           ;get last cursor placement
     add      ax,0ah              ;add 10 to it
     cmp      al,42h              ;past end of line?
     jg       cua                 ;yes, jump to add line
cur  mov      curpos,ax           ;store new placement
     mov      dx,ax               ;move into dx
     cursor                       ;set cursor position
     ret                          ;return
cua  mov      al,05               ;set column to 5
     add      ah,1                ;add line number
     cmp      ah,18h
     jge      newpage
     jmps     cur                 ;jump
newpage
     mov      ah,7
     int      21h
     clrscrn
     mov      ax,0105h
     mov      dx,ax
     mov      curpos,ax
     jmps     cur

sort xor      dx,dx               ;zero dx
     mov      ax,offset(sto_num)  ;get address of stored numbers
     mov      si,ax               ;move it to si
     mov      ax,offset(sto_let)  ;get address for stored letters
     mov      di,ax               ;move it to di
     xor      ax,ax               ;zero ax
     mov      cx,7
sorta call     let
     loop     sorta
plp  print    sto_let             ;print letter string
plx  ret                          ;return

let  push     cx
     push     ax
     mov      bx,offset(table1)   ;address table 1 in bx
     xlat                         ;counter from table 0/1/2
     mov      dx,ax               ;counter to dx
     lodsb
     mov      cl,03               ;multiply for table offset
     mul      al,cl
     add      ax,dx               ;add counter
     mov      bx,offset(table2)   ;get letter from table
     xlat
     stosb                        ;store it
     pop      ax
     inc      al
     pop      cx
     ret

another print again               ;print again message
     mov      ax,offset(table1)
     mov      di,ax
     xor      ax,ax
     mov      cx,7
     stosb                        ;reinitialize table 1
     repnz
     mov      ah,7                ;get character, no echo
     int      21h
     cmp      al,'Y'              ;if Y/y then zero set
     jz       yes
     cmp      al,'y'
yes  clrscrn
     ret                          ;otherwise return with not set

opening db    '              ͻ',cr,lf
     db       '                Convert telephone numbers to letters  ',cr,lf
     db       '                     Just type in your number.        ',cr,lf
     db       '                Do not include dashes, slashes, etc.  ',cr,lf
     db       '                Then a screen of letter substitutions ',cr,lf
     db       '                will appear.  When ready for the next ',cr,lf
     db       '                screen, hit any key to continue.      ',cr,lf
     db       '                There are 2,187 sets for any number.  ',cr,lf
     db       '              ͼ',cr,lf,'$'

expl_num db   cr,lf,'Type number without dashes (1234567): ','$'

again db      cr,lf,'Do you want to try another number? (y/n) ','$'

count dw      7
curpos dw     0

table1 ds     0ah,0               ;table initially all zeroes

table2                            ;table of letters
     db       '0','0','0'
     db       '1','1','1'
     db       'A','B','C'
     db       'D','E','F'
     db       'G','H','I'
     db       'J','K','L'
     db       'M','N','O'
     db       'P','R','S'
     db       'T','U','V'
     db       'W','X','Y'

sto_num ds    7,0                 ;storage for phone number

sto_let ds    7,0                 ;storage for letter string
     db       '$'

     endp

