;----------------------------------------------------------------;
;phonword.asm  a program to show phone # that matches a word     ;
; test version 1.0                                               ;
;----------------------------------------------------------------;


print macro                       ;macro to print
   mov   ah,9                     ;to screen
   mov   dx,offset(%1)
   int   21h
   endm

cursor macro                      ;macro to place cursor
   push  bx
   mov   bh,0
   mov   ah,2
   int   10h
   pop   bx
   endm

clrscrn macro                     ;macro to clear screen
   push  ax
   push  bx
   mov   ah,0fh
   int   10h
   mov   ah,0
   int   10h
   pop   bx
   pop   ax
   endm

getc macro                        ;macro to get characters
     mov      ah,1
     int      21h
     endm

lf   equ      0ah                 ;line feed
cr   equ      0dh                 ;carriage return

phoneword proc near

start         clrscrn             ;clear screen

     print    opening             ;print opening message

program call    get_wrd           ;program call routines get 
     call  prn_chr                ; word, print numbers,
     call  another                ; check if another wanted
     jz    program                ; if yes, jump to start
     mov   ax,4c00h               ; if no, exit
     int   21h

get_wrd                           ;get word routine
     mov      dx,0803h            ;location for word
     cursor                       ;place cursor
     print    expl_wrd            ;print message
     mov      cx,7                ;set counter
     mov      ax,offset(sto_wrd)  ;put address for storing word
     mov      di,ax               ; into di
gw1  getc                         ;get the character
     cmp      al,40h              ;number or letter?
     jl       anumb               ;number, jump
     cmp      al,60h              ;upper or lower case?
     jl       upc                 ;upper, jump
     sub      al,20h              ;shift to upper
upc  sub      al,41h              ;ready for table offset
     jmps     str                 ;jump around numb routine
anumb and     al,0fh              ;strip ascii 3 off
     add      al,1ah              ;ready for table offset
str  stosb                        ;store the number
     loop     gw1                 ;loop for all 7 letters
     ret                          ;return

prn_chr                           ;print numbers routine
     mov      dx,0b05h            ;set cursor postion
     cursor                       ;place cursor there
     xor      dx,dx               ;zero dx
     mov      ax,offset(sto_wrd)  ;get address of stored word
     mov      si,ax               ;move it to si
     mov      ax,offset(sto_nbr)  ;get address for stored numbers
     mov      di,ax               ;move it to di
     xor      ax,ax               ;zero ax
     mov      cx,7                ;initialize counter
pca  lodsb                        ;get next letter
     mov      bx,offset(table)    ;get address of table
     xlat                         ;get letter from table
     stosb                        ;store it
     loop     pca                 ;check counter and do again
pnp  print    sto_nbr             ;print number string
pnx  ret                          ;return

another print again               ;print again message
     mov      ah,7                ;get character, no echo
     int      21h
     cmp      al,'Y'              ;if Y/y then zero set
     jz       yes
     cmp      al,'y'
yes  clrscrn
     ret                          ;otherwise return with zero not set

opening db    '              ͻ',cr,lf
     db       '                Convert words to telephone numbers    ',cr,lf
     db       '                     Just type in your word.          ',cr,lf
     db       '                Do not include dashes, slashes, etc.  ',cr,lf
     db       '                Then a phone number representing      ',cr,lf
     db       '                those letters will appear.  You may   ',cr,lf
     db       '                use numbers if you choose.  The Q     ',cr,lf
     db       '                and Z are not used on the phone.      ',cr,lf
     db       '              ͼ',cr,lf,'$'

expl_wrd db   cr,lf,'Type word you want converted: $'

again db      cr,lf,'Do you want to try another word? (y/n) $'

count dw      7

table                             ;table of letters
     db       '2','2','2'         ;ABC
     db       '3','3','3'         ;DEF
     db       '4','4','4'         ;GHI
     db       '5','5','5'         ;JKL
     db       '6','6','6'         ;MNO
     db       '7','*','7','7'     ;P*RS
     db       '8','8','8'         ;TUV
     db       '9','9','9','*'     ;WXY*
     db       '0','1','2','3','4' ;0-
     db       '5','6','7','8','9' ;  9

sto_wrd ds    7,0                 ;storage for word

sto_nbr ds    7,0                 ;storage for number string
     db       '$'

     endp

